public inbox for pmg-devel@lists.proxmox.com
 help / color / mirror / Atom feed
From: Maximiliano Sandoval <m.sandoval@proxmox.com>
To: pmg-devel@lists.proxmox.com
Subject: [pmg-devel] [PATCH pmg-api v2 9/9] fix #4926: run pmg-smtp-filter and pmgpolicy without root rights
Date: Wed, 29 May 2024 16:13:03 +0200	[thread overview]
Message-ID: <20240529141303.553602-10-m.sandoval@proxmox.com> (raw)
In-Reply-To: <20240529141303.553602-1-m.sandoval@proxmox.com>

New users 'pmg-smpt-filter' and 'pmgpolicy' are created for their
respective processes and we set their systemd units to use them.

Signed-off-by: Maximiliano Sandoval <m.sandoval@proxmox.com>
---
 debian/pmg-smtp-filter.service |  2 ++
 debian/pmgpolicy.service       |  2 ++
 debian/postinst                | 28 ++++++++++++++++++++++++++++
 3 files changed, 32 insertions(+)

diff --git a/debian/pmg-smtp-filter.service b/debian/pmg-smtp-filter.service
index c887dc2..c4d5e38 100644
--- a/debian/pmg-smtp-filter.service
+++ b/debian/pmg-smtp-filter.service
@@ -16,6 +16,8 @@ Type=forking
 Restart=on-abort
 RestartSec=10
 RuntimeDirectory=pmg-smtp-filter
+User=pmg-smtp-filter
+Group=pmg-smtp-filter
 
 [Install]
 WantedBy=multi-user.target
diff --git a/debian/pmgpolicy.service b/debian/pmgpolicy.service
index 21a403f..cd8ee60 100644
--- a/debian/pmgpolicy.service
+++ b/debian/pmgpolicy.service
@@ -13,6 +13,8 @@ ExecReload=/bin/kill -HUP $MAINPID
 PIDFile=/run/pmgpolicy/pmgpolicy.pid
 Type=forking
 RuntimeDirectory=pmgpolicy
+User=pmgpolicy
+Group=pmgpolicy
 
 [Install]
 WantedBy=multi-user.target
diff --git a/debian/postinst b/debian/postinst
index 716a5af..a00c99b 100644
--- a/debian/postinst
+++ b/debian/postinst
@@ -50,6 +50,8 @@ migrate_apt_auth_conf() {
 
 migrate_pmg_smtp_filter() {
     PMG_GROUP="pmg"
+    PMGPOLICY_USER="pmgpolicy"
+    PMG_SMTP_FILTER_USER="pmg-smtp-filter"
 
     # Add shared pmg group for shared functionality, e.g. rrdcached
     if ! getent group | grep -q "^$PMG_GROUP:" ; then
@@ -58,6 +60,32 @@ migrate_pmg_smtp_filter() {
         echo "..done"
     fi
 
+    for user in $PMGPOLICY_USER $PMG_SMTP_FILTER_USER; do
+        if ! getent passwd | grep -q "^$user:"; then
+            echo -n "Adding system user $user.."
+            adduser --quiet \
+                --system \
+                --no-create-home \
+                --disabled-password \
+                --home /nonexistent \
+                --group \
+                $user 2>/dev/null || true
+            echo "..done"
+        fi
+
+        if ! getent group $PMG_GROUP | grep -q "$user"; then
+            echo -n "Adding user $user to $PMG_GROUP group.."
+            adduser --quiet $user $PMG_GROUP 2>/dev/null ||true
+            echo "..done"
+        fi
+
+        if ! getent group systemd-journal | grep -q $user ; then
+            echo -n "Adding user $user to systemd-journal group.."
+            adduser --quiet $user systemd-journal 2>/dev/null ||true
+            echo "..done"
+        fi
+    done
+
     chown :pmg /var/spool/pmg/active
     chown :pmg /var/spool/pmg/virus
     chown :pmg /var/spool/pmg/spam
-- 
2.39.2



_______________________________________________
pmg-devel mailing list
pmg-devel@lists.proxmox.com
https://lists.proxmox.com/cgi-bin/mailman/listinfo/pmg-devel


      parent reply	other threads:[~2024-05-29 14:13 UTC|newest]

Thread overview: 10+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2024-05-29 14:12 [pmg-devel] [PATCH pmg-api v2 0/9] " Maximiliano Sandoval
2024-05-29 14:12 ` [pmg-devel] [PATCH pmg-api v2 1/9] pmgpolicy: move pid file into /run/pmgpolicy Maximiliano Sandoval
2024-05-29 14:12 ` [pmg-devel] [PATCH pmg-api v2 2/9] pmg-smtp-filter: move pid file into /run/pmg-smtp-filter Maximiliano Sandoval
2024-05-29 14:12 ` [pmg-devel] [PATCH pmg-api v2 3/9] config: store config lock in smtp-filter runtime dir Maximiliano Sandoval
2024-05-29 14:12 ` [pmg-devel] [PATCH pmg-api v2 4/9] create new users for the rule db Maximiliano Sandoval
2024-05-29 14:12 ` [pmg-devel] [PATCH pmg-api v2 5/9] postinstall: add new user for shared functionality Maximiliano Sandoval
2024-05-29 14:13 ` [pmg-devel] [PATCH pmg-api v2 6/9] postinstall: make rrdcached be readable by the pmg group Maximiliano Sandoval
2024-05-29 14:13 ` [pmg-devel] [PATCH pmg-api v2 7/9] spamasassin: store files in dir managed by pmg Maximiliano Sandoval
2024-05-29 14:13 ` [pmg-devel] [PATCH pmg-api v2 8/9] mailqueue: make mail queue writable by pmg group Maximiliano Sandoval
2024-05-29 14:13 ` Maximiliano Sandoval [this message]

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20240529141303.553602-10-m.sandoval@proxmox.com \
    --to=m.sandoval@proxmox.com \
    --cc=pmg-devel@lists.proxmox.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox
Service provided by Proxmox Server Solutions GmbH | Privacy | Legal